//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Locking
{
    
    
    /// <summary>
    /// A class that exposes the ILockController interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class LockControllerProvider : IFeatureProvider
    {
        
        private ILockController _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(LockControllerProvider).Assembly, "LockController.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public LockControllerProvider(ILockController implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<LockServerRequestDto, EmptyRequest>("LockServer", LockServer);
            registration.RegisterUnobservableCommand<UnlockServerRequestDto, EmptyRequest>("UnlockServer", UnlockServer);
            registration.RegisterUnobservableProperty("IsLocked", GetIsLocked);
            registration.RegisterMetadata("LockIdentifier", _implementation.LockIdentifier);
        }
        
        /// <summary>
        /// Executes the Lock Server command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest LockServer(LockServerRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.LockServer(request.LockIdentifier.TryExtract(_server, "org.silastandard/core/LockController/v1/Command/LockServer/Parameter/LockIdentifi" +
                            "er"), request.Timeout.TryExtract(_server, "org.silastandard/core/LockController/v1/Command/LockServer/Parameter/Timeout"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "lockIdentifier"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/LockController/v1/Command/LockServer/Parameter/LockIdentifi" +
                            "er", ex.Message);
                }
                if ((ex.ParamName == "timeout"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/LockController/v1/Command/LockServer/Parameter/Timeout", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (ServerAlreadyLockedException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core/LockController/v1/DefinedExecutionError/ServerAlreadyLocked" +
                        "", "The SiLA Server can not be locked because it is already locked.", ex.Message);
            }
        }
        
        /// <summary>
        /// Executes the Unlock Server command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest UnlockServer(UnlockServerRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.UnlockServer(request.LockIdentifier.TryExtract(_server, "org.silastandard/core/LockController/v1/Command/UnlockServer/Parameter/LockIdenti" +
                            "fier"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "lockIdentifier"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/LockController/v1/Command/UnlockServer/Parameter/LockIdenti" +
                            "fier", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (ServerNotLockedException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core/LockController/v1/DefinedExecutionError/ServerNotLocked", "The SiLA Server can not be unlocked because it is not locked.", ex.Message);
            } catch (InvalidLockIdentifierException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core/LockController/v1/DefinedExecutionError/InvalidLockIdentifi" +
                        "er", "The sent lock identifier is not valid.", ex.Message);
            }
        }
        
        /// <summary>
        /// Gets the current value of the IsLocked property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.BooleanDto> GetIsLocked()
        {
            return new PropertyResponse<Tecan.Sila2.BooleanDto>(new Tecan.Sila2.BooleanDto(_implementation.IsLocked, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/core/LockController/v1/Command/LockServer"))
            {
                return typeof(ILockController).GetMethod("LockServer");
            }
            if ((commandIdentifier == "org.silastandard/core/LockController/v1/Command/UnlockServer"))
            {
                return typeof(ILockController).GetMethod("UnlockServer");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/core/LockController/v1/Property/IsLocked"))
            {
                return typeof(ILockController).GetProperty("IsLocked");
            }
            return null;
        }
    }
    
    /// <summary>
    /// An abstract base class to support the Lock Identifier metadata
    /// </summary>
    public abstract partial class LockIdentifierInterceptorBase : Tecan.Sila2.Server.IRequestInterceptor
    {
        
        /// <summary>
        /// Gets whether the metadata applies to commands
        /// </summary>
        /// <returns>True, if the metadata is applicable to commands, otherwise false.</returns>
        public abstract bool AppliesToCommands
        {
            get;
        }
        
        /// <summary>
        /// Gets whether the metadata applies to properties
        /// </summary>
        /// <returns>True, if the metadata is applicable to properties, otherwise false.</returns>
        public abstract bool AppliesToProperties
        {
            get;
        }
        
        /// <summary>
        /// Gets the priority for the metadata
        /// </summary>
        /// <returns>A relative priority.</returns>
        public abstract int Priority
        {
            get;
        }
        
        /// <summary>
        /// Gets the metadata identifier this request interceptor is connected to or null, if not applicable
        /// </summary>
        public string MetadataIdentifier
        {
            get
            {
                return "org.silastandard/core/LockController/v1/Metadata/LockIdentifier";
            }
        }
        
        /// <summary>
        /// Decides whether the interceptor is required for the given command
        /// </summary>
        /// <param name="feature">The feature that contains the command or property</param>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <returns>True, if the interceptor should be applied</returns>
        public abstract bool IsInterceptRequired(Feature feature, string commandIdentifier);
        
        /// <summary>
        /// Intercepts the call to the given command
        /// </summary>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <param name="lockIdentifier">The parsed metadata</param>
        /// <returns>A request interception or null, if this is not necessary</returns>
        public abstract Tecan.Sila2.Server.IRequestInterception Intercept(string commandIdentifier, string lockIdentifier);
        
        /// <summary>
        /// Intercepts the call to the given command
        /// </summary>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <param name="server">The server that should execute the request</param>
        /// <param name="metadata">The metadata attached to the request</param>
        /// <returns>A request interception or null, if this is not necessary</returns>
        public Tecan.Sila2.Server.IRequestInterception Intercept(string commandIdentifier, Tecan.Sila2.Server.ISiLAServer server, Tecan.Sila2.Server.IMetadataRepository metadata)
        {
            try
            {
                return Intercept(commandIdentifier, Tecan.Sila2.Server.Metadata.Extract<Tecan.Sila2.StringDto>(metadata, MetadataIdentifier).Extract(server));
            } catch (InvalidLockIdentifierException ex)
            {
                throw server.ErrorHandling.CreateExecutionError("org.silastandard/core/LockController/v1/DefinedExecutionError/InvalidLockIdentifi" +
                        "er", "The sent lock identifier is not valid.", ex.Message);
            }
        }
    }
}

